// Code generated by pulumi-language-go DO NOT EDIT.
// *** WARNING: Do not edit by hand unless you're certain you know what you are doing! ***

package pvecluster

import (
	"context"
	"reflect"

	"github.com/pulumi/pulumi/sdk/v3/go/pulumi"
	"internal"
)

var _ = internal.GetEnvOrDefault

type ChunkConfig struct {
	Coding int `pulumi:"coding"`
	Data   int `pulumi:"data"`
}

// ChunkConfigInput is an input type that accepts ChunkConfigArgs and ChunkConfigOutput values.
// You can construct a concrete instance of `ChunkConfigInput` via:
//
//	ChunkConfigArgs{...}
type ChunkConfigInput interface {
	pulumi.Input

	ToChunkConfigOutput() ChunkConfigOutput
	ToChunkConfigOutputWithContext(context.Context) ChunkConfigOutput
}

type ChunkConfigArgs struct {
	Coding pulumi.IntInput `pulumi:"coding"`
	Data   pulumi.IntInput `pulumi:"data"`
}

func (ChunkConfigArgs) ElementType() reflect.Type {
	return reflect.TypeOf((*ChunkConfig)(nil)).Elem()
}

func (i ChunkConfigArgs) ToChunkConfigOutput() ChunkConfigOutput {
	return i.ToChunkConfigOutputWithContext(context.Background())
}

func (i ChunkConfigArgs) ToChunkConfigOutputWithContext(ctx context.Context) ChunkConfigOutput {
	return pulumi.ToOutputWithContext(ctx, i).(ChunkConfigOutput)
}

func (i ChunkConfigArgs) ToChunkConfigPtrOutput() ChunkConfigPtrOutput {
	return i.ToChunkConfigPtrOutputWithContext(context.Background())
}

func (i ChunkConfigArgs) ToChunkConfigPtrOutputWithContext(ctx context.Context) ChunkConfigPtrOutput {
	return pulumi.ToOutputWithContext(ctx, i).(ChunkConfigOutput).ToChunkConfigPtrOutputWithContext(ctx)
}

// ChunkConfigPtrInput is an input type that accepts ChunkConfigArgs, ChunkConfigPtr and ChunkConfigPtrOutput values.
// You can construct a concrete instance of `ChunkConfigPtrInput` via:
//
//	        ChunkConfigArgs{...}
//
//	or:
//
//	        nil
type ChunkConfigPtrInput interface {
	pulumi.Input

	ToChunkConfigPtrOutput() ChunkConfigPtrOutput
	ToChunkConfigPtrOutputWithContext(context.Context) ChunkConfigPtrOutput
}

type chunkConfigPtrType ChunkConfigArgs

func ChunkConfigPtr(v *ChunkConfigArgs) ChunkConfigPtrInput {
	return (*chunkConfigPtrType)(v)
}

func (*chunkConfigPtrType) ElementType() reflect.Type {
	return reflect.TypeOf((**ChunkConfig)(nil)).Elem()
}

func (i *chunkConfigPtrType) ToChunkConfigPtrOutput() ChunkConfigPtrOutput {
	return i.ToChunkConfigPtrOutputWithContext(context.Background())
}

func (i *chunkConfigPtrType) ToChunkConfigPtrOutputWithContext(ctx context.Context) ChunkConfigPtrOutput {
	return pulumi.ToOutputWithContext(ctx, i).(ChunkConfigPtrOutput)
}

type ChunkConfigOutput struct{ *pulumi.OutputState }

func (ChunkConfigOutput) ElementType() reflect.Type {
	return reflect.TypeOf((*ChunkConfig)(nil)).Elem()
}

func (o ChunkConfigOutput) ToChunkConfigOutput() ChunkConfigOutput {
	return o
}

func (o ChunkConfigOutput) ToChunkConfigOutputWithContext(ctx context.Context) ChunkConfigOutput {
	return o
}

func (o ChunkConfigOutput) ToChunkConfigPtrOutput() ChunkConfigPtrOutput {
	return o.ToChunkConfigPtrOutputWithContext(context.Background())
}

func (o ChunkConfigOutput) ToChunkConfigPtrOutputWithContext(ctx context.Context) ChunkConfigPtrOutput {
	return o.ApplyTWithContext(ctx, func(_ context.Context, v ChunkConfig) *ChunkConfig {
		return &v
	}).(ChunkConfigPtrOutput)
}

func (o ChunkConfigOutput) Coding() pulumi.IntOutput {
	return o.ApplyT(func(v ChunkConfig) int { return v.Coding }).(pulumi.IntOutput)
}

func (o ChunkConfigOutput) Data() pulumi.IntOutput {
	return o.ApplyT(func(v ChunkConfig) int { return v.Data }).(pulumi.IntOutput)
}

type ChunkConfigPtrOutput struct{ *pulumi.OutputState }

func (ChunkConfigPtrOutput) ElementType() reflect.Type {
	return reflect.TypeOf((**ChunkConfig)(nil)).Elem()
}

func (o ChunkConfigPtrOutput) ToChunkConfigPtrOutput() ChunkConfigPtrOutput {
	return o
}

func (o ChunkConfigPtrOutput) ToChunkConfigPtrOutputWithContext(ctx context.Context) ChunkConfigPtrOutput {
	return o
}

func (o ChunkConfigPtrOutput) Elem() ChunkConfigOutput {
	return o.ApplyT(func(v *ChunkConfig) ChunkConfig {
		if v != nil {
			return *v
		}
		var ret ChunkConfig
		return ret
	}).(ChunkConfigOutput)
}

func (o ChunkConfigPtrOutput) Coding() pulumi.IntPtrOutput {
	return o.ApplyT(func(v *ChunkConfig) *int {
		if v == nil {
			return nil
		}
		return &v.Coding
	}).(pulumi.IntPtrOutput)
}

func (o ChunkConfigPtrOutput) Data() pulumi.IntPtrOutput {
	return o.ApplyT(func(v *ChunkConfig) *int {
		if v == nil {
			return nil
		}
		return &v.Data
	}).(pulumi.IntPtrOutput)
}

type ClusterConfig struct {
	Chunks      *ChunkConfig `pulumi:"chunks"`
	DeviceClass *string      `pulumi:"deviceClass"`
	Name        string       `pulumi:"name"`
	Replicas    *int         `pulumi:"replicas"`
}

// ClusterConfigInput is an input type that accepts ClusterConfigArgs and ClusterConfigOutput values.
// You can construct a concrete instance of `ClusterConfigInput` via:
//
//	ClusterConfigArgs{...}
type ClusterConfigInput interface {
	pulumi.Input

	ToClusterConfigOutput() ClusterConfigOutput
	ToClusterConfigOutputWithContext(context.Context) ClusterConfigOutput
}

type ClusterConfigArgs struct {
	Chunks      ChunkConfigPtrInput   `pulumi:"chunks"`
	DeviceClass pulumi.StringPtrInput `pulumi:"deviceClass"`
	Name        pulumi.StringInput    `pulumi:"name"`
	Replicas    pulumi.IntPtrInput    `pulumi:"replicas"`
}

func (ClusterConfigArgs) ElementType() reflect.Type {
	return reflect.TypeOf((*ClusterConfig)(nil)).Elem()
}

func (i ClusterConfigArgs) ToClusterConfigOutput() ClusterConfigOutput {
	return i.ToClusterConfigOutputWithContext(context.Background())
}

func (i ClusterConfigArgs) ToClusterConfigOutputWithContext(ctx context.Context) ClusterConfigOutput {
	return pulumi.ToOutputWithContext(ctx, i).(ClusterConfigOutput)
}

func (i ClusterConfigArgs) ToClusterConfigPtrOutput() ClusterConfigPtrOutput {
	return i.ToClusterConfigPtrOutputWithContext(context.Background())
}

func (i ClusterConfigArgs) ToClusterConfigPtrOutputWithContext(ctx context.Context) ClusterConfigPtrOutput {
	return pulumi.ToOutputWithContext(ctx, i).(ClusterConfigOutput).ToClusterConfigPtrOutputWithContext(ctx)
}

// ClusterConfigPtrInput is an input type that accepts ClusterConfigArgs, ClusterConfigPtr and ClusterConfigPtrOutput values.
// You can construct a concrete instance of `ClusterConfigPtrInput` via:
//
//	        ClusterConfigArgs{...}
//
//	or:
//
//	        nil
type ClusterConfigPtrInput interface {
	pulumi.Input

	ToClusterConfigPtrOutput() ClusterConfigPtrOutput
	ToClusterConfigPtrOutputWithContext(context.Context) ClusterConfigPtrOutput
}

type clusterConfigPtrType ClusterConfigArgs

func ClusterConfigPtr(v *ClusterConfigArgs) ClusterConfigPtrInput {
	return (*clusterConfigPtrType)(v)
}

func (*clusterConfigPtrType) ElementType() reflect.Type {
	return reflect.TypeOf((**ClusterConfig)(nil)).Elem()
}

func (i *clusterConfigPtrType) ToClusterConfigPtrOutput() ClusterConfigPtrOutput {
	return i.ToClusterConfigPtrOutputWithContext(context.Background())
}

func (i *clusterConfigPtrType) ToClusterConfigPtrOutputWithContext(ctx context.Context) ClusterConfigPtrOutput {
	return pulumi.ToOutputWithContext(ctx, i).(ClusterConfigPtrOutput)
}

type ClusterConfigOutput struct{ *pulumi.OutputState }

func (ClusterConfigOutput) ElementType() reflect.Type {
	return reflect.TypeOf((*ClusterConfig)(nil)).Elem()
}

func (o ClusterConfigOutput) ToClusterConfigOutput() ClusterConfigOutput {
	return o
}

func (o ClusterConfigOutput) ToClusterConfigOutputWithContext(ctx context.Context) ClusterConfigOutput {
	return o
}

func (o ClusterConfigOutput) ToClusterConfigPtrOutput() ClusterConfigPtrOutput {
	return o.ToClusterConfigPtrOutputWithContext(context.Background())
}

func (o ClusterConfigOutput) ToClusterConfigPtrOutputWithContext(ctx context.Context) ClusterConfigPtrOutput {
	return o.ApplyTWithContext(ctx, func(_ context.Context, v ClusterConfig) *ClusterConfig {
		return &v
	}).(ClusterConfigPtrOutput)
}

func (o ClusterConfigOutput) Chunks() ChunkConfigPtrOutput {
	return o.ApplyT(func(v ClusterConfig) *ChunkConfig { return v.Chunks }).(ChunkConfigPtrOutput)
}

func (o ClusterConfigOutput) DeviceClass() pulumi.StringPtrOutput {
	return o.ApplyT(func(v ClusterConfig) *string { return v.DeviceClass }).(pulumi.StringPtrOutput)
}

func (o ClusterConfigOutput) Name() pulumi.StringOutput {
	return o.ApplyT(func(v ClusterConfig) string { return v.Name }).(pulumi.StringOutput)
}

func (o ClusterConfigOutput) Replicas() pulumi.IntPtrOutput {
	return o.ApplyT(func(v ClusterConfig) *int { return v.Replicas }).(pulumi.IntPtrOutput)
}

type ClusterConfigPtrOutput struct{ *pulumi.OutputState }

func (ClusterConfigPtrOutput) ElementType() reflect.Type {
	return reflect.TypeOf((**ClusterConfig)(nil)).Elem()
}

func (o ClusterConfigPtrOutput) ToClusterConfigPtrOutput() ClusterConfigPtrOutput {
	return o
}

func (o ClusterConfigPtrOutput) ToClusterConfigPtrOutputWithContext(ctx context.Context) ClusterConfigPtrOutput {
	return o
}

func (o ClusterConfigPtrOutput) Elem() ClusterConfigOutput {
	return o.ApplyT(func(v *ClusterConfig) ClusterConfig {
		if v != nil {
			return *v
		}
		var ret ClusterConfig
		return ret
	}).(ClusterConfigOutput)
}

func (o ClusterConfigPtrOutput) Chunks() ChunkConfigPtrOutput {
	return o.ApplyT(func(v *ClusterConfig) *ChunkConfig {
		if v == nil {
			return nil
		}
		return v.Chunks
	}).(ChunkConfigPtrOutput)
}

func (o ClusterConfigPtrOutput) DeviceClass() pulumi.StringPtrOutput {
	return o.ApplyT(func(v *ClusterConfig) *string {
		if v == nil {
			return nil
		}
		return v.DeviceClass
	}).(pulumi.StringPtrOutput)
}

func (o ClusterConfigPtrOutput) Name() pulumi.StringPtrOutput {
	return o.ApplyT(func(v *ClusterConfig) *string {
		if v == nil {
			return nil
		}
		return &v.Name
	}).(pulumi.StringPtrOutput)
}

func (o ClusterConfigPtrOutput) Replicas() pulumi.IntPtrOutput {
	return o.ApplyT(func(v *ClusterConfig) *int {
		if v == nil {
			return nil
		}
		return v.Replicas
	}).(pulumi.IntPtrOutput)
}

type Connection struct {
	Host           string  `pulumi:"host"`
	Port           *int    `pulumi:"port"`
	PrivateKey     string  `pulumi:"privateKey"`
	PrivateKeyPass *string `pulumi:"privateKeyPass"`
	User           *string `pulumi:"user"`
}

// ConnectionInput is an input type that accepts ConnectionArgs and ConnectionOutput values.
// You can construct a concrete instance of `ConnectionInput` via:
//
//	ConnectionArgs{...}
type ConnectionInput interface {
	pulumi.Input

	ToConnectionOutput() ConnectionOutput
	ToConnectionOutputWithContext(context.Context) ConnectionOutput
}

type ConnectionArgs struct {
	Host           pulumi.StringInput    `pulumi:"host"`
	Port           pulumi.IntPtrInput    `pulumi:"port"`
	PrivateKey     pulumi.StringInput    `pulumi:"privateKey"`
	PrivateKeyPass pulumi.StringPtrInput `pulumi:"privateKeyPass"`
	User           pulumi.StringPtrInput `pulumi:"user"`
}

func (ConnectionArgs) ElementType() reflect.Type {
	return reflect.TypeOf((*Connection)(nil)).Elem()
}

func (i ConnectionArgs) ToConnectionOutput() ConnectionOutput {
	return i.ToConnectionOutputWithContext(context.Background())
}

func (i ConnectionArgs) ToConnectionOutputWithContext(ctx context.Context) ConnectionOutput {
	return pulumi.ToOutputWithContext(ctx, i).(ConnectionOutput)
}

type ConnectionOutput struct{ *pulumi.OutputState }

func (ConnectionOutput) ElementType() reflect.Type {
	return reflect.TypeOf((*Connection)(nil)).Elem()
}

func (o ConnectionOutput) ToConnectionOutput() ConnectionOutput {
	return o
}

func (o ConnectionOutput) ToConnectionOutputWithContext(ctx context.Context) ConnectionOutput {
	return o
}

func (o ConnectionOutput) Host() pulumi.StringOutput {
	return o.ApplyT(func(v Connection) string { return v.Host }).(pulumi.StringOutput)
}

func (o ConnectionOutput) Port() pulumi.IntPtrOutput {
	return o.ApplyT(func(v Connection) *int { return v.Port }).(pulumi.IntPtrOutput)
}

func (o ConnectionOutput) PrivateKey() pulumi.StringOutput {
	return o.ApplyT(func(v Connection) string { return v.PrivateKey }).(pulumi.StringOutput)
}

func (o ConnectionOutput) PrivateKeyPass() pulumi.StringPtrOutput {
	return o.ApplyT(func(v Connection) *string { return v.PrivateKeyPass }).(pulumi.StringPtrOutput)
}

func (o ConnectionOutput) User() pulumi.StringPtrOutput {
	return o.ApplyT(func(v Connection) *string { return v.User }).(pulumi.StringPtrOutput)
}

type ConnectionConfig struct {
	Host           string  `pulumi:"host"`
	Port           *int    `pulumi:"port"`
	PrivateKeyPass *string `pulumi:"privateKeyPass"`
	PrivateKeyPath string  `pulumi:"privateKeyPath"`
	User           *string `pulumi:"user"`
}

// ConnectionConfigInput is an input type that accepts ConnectionConfigArgs and ConnectionConfigOutput values.
// You can construct a concrete instance of `ConnectionConfigInput` via:
//
//	ConnectionConfigArgs{...}
type ConnectionConfigInput interface {
	pulumi.Input

	ToConnectionConfigOutput() ConnectionConfigOutput
	ToConnectionConfigOutputWithContext(context.Context) ConnectionConfigOutput
}

type ConnectionConfigArgs struct {
	Host           pulumi.StringInput    `pulumi:"host"`
	Port           pulumi.IntPtrInput    `pulumi:"port"`
	PrivateKeyPass pulumi.StringPtrInput `pulumi:"privateKeyPass"`
	PrivateKeyPath pulumi.StringInput    `pulumi:"privateKeyPath"`
	User           pulumi.StringPtrInput `pulumi:"user"`
}

func (ConnectionConfigArgs) ElementType() reflect.Type {
	return reflect.TypeOf((*ConnectionConfig)(nil)).Elem()
}

func (i ConnectionConfigArgs) ToConnectionConfigOutput() ConnectionConfigOutput {
	return i.ToConnectionConfigOutputWithContext(context.Background())
}

func (i ConnectionConfigArgs) ToConnectionConfigOutputWithContext(ctx context.Context) ConnectionConfigOutput {
	return pulumi.ToOutputWithContext(ctx, i).(ConnectionConfigOutput)
}

func (i ConnectionConfigArgs) ToConnectionConfigPtrOutput() ConnectionConfigPtrOutput {
	return i.ToConnectionConfigPtrOutputWithContext(context.Background())
}

func (i ConnectionConfigArgs) ToConnectionConfigPtrOutputWithContext(ctx context.Context) ConnectionConfigPtrOutput {
	return pulumi.ToOutputWithContext(ctx, i).(ConnectionConfigOutput).ToConnectionConfigPtrOutputWithContext(ctx)
}

// ConnectionConfigPtrInput is an input type that accepts ConnectionConfigArgs, ConnectionConfigPtr and ConnectionConfigPtrOutput values.
// You can construct a concrete instance of `ConnectionConfigPtrInput` via:
//
//	        ConnectionConfigArgs{...}
//
//	or:
//
//	        nil
type ConnectionConfigPtrInput interface {
	pulumi.Input

	ToConnectionConfigPtrOutput() ConnectionConfigPtrOutput
	ToConnectionConfigPtrOutputWithContext(context.Context) ConnectionConfigPtrOutput
}

type connectionConfigPtrType ConnectionConfigArgs

func ConnectionConfigPtr(v *ConnectionConfigArgs) ConnectionConfigPtrInput {
	return (*connectionConfigPtrType)(v)
}

func (*connectionConfigPtrType) ElementType() reflect.Type {
	return reflect.TypeOf((**ConnectionConfig)(nil)).Elem()
}

func (i *connectionConfigPtrType) ToConnectionConfigPtrOutput() ConnectionConfigPtrOutput {
	return i.ToConnectionConfigPtrOutputWithContext(context.Background())
}

func (i *connectionConfigPtrType) ToConnectionConfigPtrOutputWithContext(ctx context.Context) ConnectionConfigPtrOutput {
	return pulumi.ToOutputWithContext(ctx, i).(ConnectionConfigPtrOutput)
}

type ConnectionConfigOutput struct{ *pulumi.OutputState }

func (ConnectionConfigOutput) ElementType() reflect.Type {
	return reflect.TypeOf((*ConnectionConfig)(nil)).Elem()
}

func (o ConnectionConfigOutput) ToConnectionConfigOutput() ConnectionConfigOutput {
	return o
}

func (o ConnectionConfigOutput) ToConnectionConfigOutputWithContext(ctx context.Context) ConnectionConfigOutput {
	return o
}

func (o ConnectionConfigOutput) ToConnectionConfigPtrOutput() ConnectionConfigPtrOutput {
	return o.ToConnectionConfigPtrOutputWithContext(context.Background())
}

func (o ConnectionConfigOutput) ToConnectionConfigPtrOutputWithContext(ctx context.Context) ConnectionConfigPtrOutput {
	return o.ApplyTWithContext(ctx, func(_ context.Context, v ConnectionConfig) *ConnectionConfig {
		return &v
	}).(ConnectionConfigPtrOutput)
}

func (o ConnectionConfigOutput) Host() pulumi.StringOutput {
	return o.ApplyT(func(v ConnectionConfig) string { return v.Host }).(pulumi.StringOutput)
}

func (o ConnectionConfigOutput) Port() pulumi.IntPtrOutput {
	return o.ApplyT(func(v ConnectionConfig) *int { return v.Port }).(pulumi.IntPtrOutput)
}

func (o ConnectionConfigOutput) PrivateKeyPass() pulumi.StringPtrOutput {
	return o.ApplyT(func(v ConnectionConfig) *string { return v.PrivateKeyPass }).(pulumi.StringPtrOutput)
}

func (o ConnectionConfigOutput) PrivateKeyPath() pulumi.StringOutput {
	return o.ApplyT(func(v ConnectionConfig) string { return v.PrivateKeyPath }).(pulumi.StringOutput)
}

func (o ConnectionConfigOutput) User() pulumi.StringPtrOutput {
	return o.ApplyT(func(v ConnectionConfig) *string { return v.User }).(pulumi.StringPtrOutput)
}

type ConnectionConfigPtrOutput struct{ *pulumi.OutputState }

func (ConnectionConfigPtrOutput) ElementType() reflect.Type {
	return reflect.TypeOf((**ConnectionConfig)(nil)).Elem()
}

func (o ConnectionConfigPtrOutput) ToConnectionConfigPtrOutput() ConnectionConfigPtrOutput {
	return o
}

func (o ConnectionConfigPtrOutput) ToConnectionConfigPtrOutputWithContext(ctx context.Context) ConnectionConfigPtrOutput {
	return o
}

func (o ConnectionConfigPtrOutput) Elem() ConnectionConfigOutput {
	return o.ApplyT(func(v *ConnectionConfig) ConnectionConfig {
		if v != nil {
			return *v
		}
		var ret ConnectionConfig
		return ret
	}).(ConnectionConfigOutput)
}

func (o ConnectionConfigPtrOutput) Host() pulumi.StringPtrOutput {
	return o.ApplyT(func(v *ConnectionConfig) *string {
		if v == nil {
			return nil
		}
		return &v.Host
	}).(pulumi.StringPtrOutput)
}

func (o ConnectionConfigPtrOutput) Port() pulumi.IntPtrOutput {
	return o.ApplyT(func(v *ConnectionConfig) *int {
		if v == nil {
			return nil
		}
		return v.Port
	}).(pulumi.IntPtrOutput)
}

func (o ConnectionConfigPtrOutput) PrivateKeyPass() pulumi.StringPtrOutput {
	return o.ApplyT(func(v *ConnectionConfig) *string {
		if v == nil {
			return nil
		}
		return v.PrivateKeyPass
	}).(pulumi.StringPtrOutput)
}

func (o ConnectionConfigPtrOutput) PrivateKeyPath() pulumi.StringPtrOutput {
	return o.ApplyT(func(v *ConnectionConfig) *string {
		if v == nil {
			return nil
		}
		return &v.PrivateKeyPath
	}).(pulumi.StringPtrOutput)
}

func (o ConnectionConfigPtrOutput) User() pulumi.StringPtrOutput {
	return o.ApplyT(func(v *ConnectionConfig) *string {
		if v == nil {
			return nil
		}
		return v.User
	}).(pulumi.StringPtrOutput)
}

type Disk struct {
	Id string `pulumi:"id"`
}

// DiskInput is an input type that accepts DiskArgs and DiskOutput values.
// You can construct a concrete instance of `DiskInput` via:
//
//	DiskArgs{...}
type DiskInput interface {
	pulumi.Input

	ToDiskOutput() DiskOutput
	ToDiskOutputWithContext(context.Context) DiskOutput
}

type DiskArgs struct {
	Id pulumi.StringInput `pulumi:"id"`
}

func (DiskArgs) ElementType() reflect.Type {
	return reflect.TypeOf((*Disk)(nil)).Elem()
}

func (i DiskArgs) ToDiskOutput() DiskOutput {
	return i.ToDiskOutputWithContext(context.Background())
}

func (i DiskArgs) ToDiskOutputWithContext(ctx context.Context) DiskOutput {
	return pulumi.ToOutputWithContext(ctx, i).(DiskOutput)
}

// DiskArrayInput is an input type that accepts DiskArray and DiskArrayOutput values.
// You can construct a concrete instance of `DiskArrayInput` via:
//
//	DiskArray{ DiskArgs{...} }
type DiskArrayInput interface {
	pulumi.Input

	ToDiskArrayOutput() DiskArrayOutput
	ToDiskArrayOutputWithContext(context.Context) DiskArrayOutput
}

type DiskArray []DiskInput

func (DiskArray) ElementType() reflect.Type {
	return reflect.TypeOf((*[]Disk)(nil)).Elem()
}

func (i DiskArray) ToDiskArrayOutput() DiskArrayOutput {
	return i.ToDiskArrayOutputWithContext(context.Background())
}

func (i DiskArray) ToDiskArrayOutputWithContext(ctx context.Context) DiskArrayOutput {
	return pulumi.ToOutputWithContext(ctx, i).(DiskArrayOutput)
}

type DiskOutput struct{ *pulumi.OutputState }

func (DiskOutput) ElementType() reflect.Type {
	return reflect.TypeOf((*Disk)(nil)).Elem()
}

func (o DiskOutput) ToDiskOutput() DiskOutput {
	return o
}

func (o DiskOutput) ToDiskOutputWithContext(ctx context.Context) DiskOutput {
	return o
}

func (o DiskOutput) Id() pulumi.StringOutput {
	return o.ApplyT(func(v Disk) string { return v.Id }).(pulumi.StringOutput)
}

type DiskArrayOutput struct{ *pulumi.OutputState }

func (DiskArrayOutput) ElementType() reflect.Type {
	return reflect.TypeOf((*[]Disk)(nil)).Elem()
}

func (o DiskArrayOutput) ToDiskArrayOutput() DiskArrayOutput {
	return o
}

func (o DiskArrayOutput) ToDiskArrayOutputWithContext(ctx context.Context) DiskArrayOutput {
	return o
}

func (o DiskArrayOutput) Index(i pulumi.IntInput) DiskOutput {
	return pulumi.All(o, i).ApplyT(func(vs []interface{}) Disk {
		return vs[0].([]Disk)[vs[1].(int)]
	}).(DiskOutput)
}

type DiskConfig struct {
	Hdds []Disk `pulumi:"hdds"`
	Ssds []SSD  `pulumi:"ssds"`
}

// DiskConfigInput is an input type that accepts DiskConfigArgs and DiskConfigOutput values.
// You can construct a concrete instance of `DiskConfigInput` via:
//
//	DiskConfigArgs{...}
type DiskConfigInput interface {
	pulumi.Input

	ToDiskConfigOutput() DiskConfigOutput
	ToDiskConfigOutputWithContext(context.Context) DiskConfigOutput
}

type DiskConfigArgs struct {
	Hdds DiskArrayInput `pulumi:"hdds"`
	Ssds SSDArrayInput  `pulumi:"ssds"`
}

func (DiskConfigArgs) ElementType() reflect.Type {
	return reflect.TypeOf((*DiskConfig)(nil)).Elem()
}

func (i DiskConfigArgs) ToDiskConfigOutput() DiskConfigOutput {
	return i.ToDiskConfigOutputWithContext(context.Background())
}

func (i DiskConfigArgs) ToDiskConfigOutputWithContext(ctx context.Context) DiskConfigOutput {
	return pulumi.ToOutputWithContext(ctx, i).(DiskConfigOutput)
}

func (i DiskConfigArgs) ToDiskConfigPtrOutput() DiskConfigPtrOutput {
	return i.ToDiskConfigPtrOutputWithContext(context.Background())
}

func (i DiskConfigArgs) ToDiskConfigPtrOutputWithContext(ctx context.Context) DiskConfigPtrOutput {
	return pulumi.ToOutputWithContext(ctx, i).(DiskConfigOutput).ToDiskConfigPtrOutputWithContext(ctx)
}

// DiskConfigPtrInput is an input type that accepts DiskConfigArgs, DiskConfigPtr and DiskConfigPtrOutput values.
// You can construct a concrete instance of `DiskConfigPtrInput` via:
//
//	        DiskConfigArgs{...}
//
//	or:
//
//	        nil
type DiskConfigPtrInput interface {
	pulumi.Input

	ToDiskConfigPtrOutput() DiskConfigPtrOutput
	ToDiskConfigPtrOutputWithContext(context.Context) DiskConfigPtrOutput
}

type diskConfigPtrType DiskConfigArgs

func DiskConfigPtr(v *DiskConfigArgs) DiskConfigPtrInput {
	return (*diskConfigPtrType)(v)
}

func (*diskConfigPtrType) ElementType() reflect.Type {
	return reflect.TypeOf((**DiskConfig)(nil)).Elem()
}

func (i *diskConfigPtrType) ToDiskConfigPtrOutput() DiskConfigPtrOutput {
	return i.ToDiskConfigPtrOutputWithContext(context.Background())
}

func (i *diskConfigPtrType) ToDiskConfigPtrOutputWithContext(ctx context.Context) DiskConfigPtrOutput {
	return pulumi.ToOutputWithContext(ctx, i).(DiskConfigPtrOutput)
}

type DiskConfigOutput struct{ *pulumi.OutputState }

func (DiskConfigOutput) ElementType() reflect.Type {
	return reflect.TypeOf((*DiskConfig)(nil)).Elem()
}

func (o DiskConfigOutput) ToDiskConfigOutput() DiskConfigOutput {
	return o
}

func (o DiskConfigOutput) ToDiskConfigOutputWithContext(ctx context.Context) DiskConfigOutput {
	return o
}

func (o DiskConfigOutput) ToDiskConfigPtrOutput() DiskConfigPtrOutput {
	return o.ToDiskConfigPtrOutputWithContext(context.Background())
}

func (o DiskConfigOutput) ToDiskConfigPtrOutputWithContext(ctx context.Context) DiskConfigPtrOutput {
	return o.ApplyTWithContext(ctx, func(_ context.Context, v DiskConfig) *DiskConfig {
		return &v
	}).(DiskConfigPtrOutput)
}

func (o DiskConfigOutput) Hdds() DiskArrayOutput {
	return o.ApplyT(func(v DiskConfig) []Disk { return v.Hdds }).(DiskArrayOutput)
}

func (o DiskConfigOutput) Ssds() SSDArrayOutput {
	return o.ApplyT(func(v DiskConfig) []SSD { return v.Ssds }).(SSDArrayOutput)
}

type DiskConfigPtrOutput struct{ *pulumi.OutputState }

func (DiskConfigPtrOutput) ElementType() reflect.Type {
	return reflect.TypeOf((**DiskConfig)(nil)).Elem()
}

func (o DiskConfigPtrOutput) ToDiskConfigPtrOutput() DiskConfigPtrOutput {
	return o
}

func (o DiskConfigPtrOutput) ToDiskConfigPtrOutputWithContext(ctx context.Context) DiskConfigPtrOutput {
	return o
}

func (o DiskConfigPtrOutput) Elem() DiskConfigOutput {
	return o.ApplyT(func(v *DiskConfig) DiskConfig {
		if v != nil {
			return *v
		}
		var ret DiskConfig
		return ret
	}).(DiskConfigOutput)
}

func (o DiskConfigPtrOutput) Hdds() DiskArrayOutput {
	return o.ApplyT(func(v *DiskConfig) []Disk {
		if v == nil {
			return nil
		}
		return v.Hdds
	}).(DiskArrayOutput)
}

func (o DiskConfigPtrOutput) Ssds() SSDArrayOutput {
	return o.ApplyT(func(v *DiskConfig) []SSD {
		if v == nil {
			return nil
		}
		return v.Ssds
	}).(SSDArrayOutput)
}

type DiskSpec struct {
	Hdds []Disk `pulumi:"hdds"`
	Ssds []SSD  `pulumi:"ssds"`
}

// DiskSpecInput is an input type that accepts DiskSpecArgs and DiskSpecOutput values.
// You can construct a concrete instance of `DiskSpecInput` via:
//
//	DiskSpecArgs{...}
type DiskSpecInput interface {
	pulumi.Input

	ToDiskSpecOutput() DiskSpecOutput
	ToDiskSpecOutputWithContext(context.Context) DiskSpecOutput
}

type DiskSpecArgs struct {
	Hdds DiskArrayInput `pulumi:"hdds"`
	Ssds SSDArrayInput  `pulumi:"ssds"`
}

func (DiskSpecArgs) ElementType() reflect.Type {
	return reflect.TypeOf((*DiskSpec)(nil)).Elem()
}

func (i DiskSpecArgs) ToDiskSpecOutput() DiskSpecOutput {
	return i.ToDiskSpecOutputWithContext(context.Background())
}

func (i DiskSpecArgs) ToDiskSpecOutputWithContext(ctx context.Context) DiskSpecOutput {
	return pulumi.ToOutputWithContext(ctx, i).(DiskSpecOutput)
}

type DiskSpecOutput struct{ *pulumi.OutputState }

func (DiskSpecOutput) ElementType() reflect.Type {
	return reflect.TypeOf((*DiskSpec)(nil)).Elem()
}

func (o DiskSpecOutput) ToDiskSpecOutput() DiskSpecOutput {
	return o
}

func (o DiskSpecOutput) ToDiskSpecOutputWithContext(ctx context.Context) DiskSpecOutput {
	return o
}

func (o DiskSpecOutput) Hdds() DiskArrayOutput {
	return o.ApplyT(func(v DiskSpec) []Disk { return v.Hdds }).(DiskArrayOutput)
}

func (o DiskSpecOutput) Ssds() SSDArrayOutput {
	return o.ApplyT(func(v DiskSpec) []SSD { return v.Ssds }).(SSDArrayOutput)
}

type NodeConfig struct {
	Connection *ConnectionConfig `pulumi:"connection"`
	Disks      DiskConfig        `pulumi:"disks"`
	Host       string            `pulumi:"host"`
}

// NodeConfigInput is an input type that accepts NodeConfigArgs and NodeConfigOutput values.
// You can construct a concrete instance of `NodeConfigInput` via:
//
//	NodeConfigArgs{...}
type NodeConfigInput interface {
	pulumi.Input

	ToNodeConfigOutput() NodeConfigOutput
	ToNodeConfigOutputWithContext(context.Context) NodeConfigOutput
}

type NodeConfigArgs struct {
	Connection ConnectionConfigPtrInput `pulumi:"connection"`
	Disks      DiskConfigInput          `pulumi:"disks"`
	Host       pulumi.StringInput       `pulumi:"host"`
}

func (NodeConfigArgs) ElementType() reflect.Type {
	return reflect.TypeOf((*NodeConfig)(nil)).Elem()
}

func (i NodeConfigArgs) ToNodeConfigOutput() NodeConfigOutput {
	return i.ToNodeConfigOutputWithContext(context.Background())
}

func (i NodeConfigArgs) ToNodeConfigOutputWithContext(ctx context.Context) NodeConfigOutput {
	return pulumi.ToOutputWithContext(ctx, i).(NodeConfigOutput)
}

func (i NodeConfigArgs) ToNodeConfigPtrOutput() NodeConfigPtrOutput {
	return i.ToNodeConfigPtrOutputWithContext(context.Background())
}

func (i NodeConfigArgs) ToNodeConfigPtrOutputWithContext(ctx context.Context) NodeConfigPtrOutput {
	return pulumi.ToOutputWithContext(ctx, i).(NodeConfigOutput).ToNodeConfigPtrOutputWithContext(ctx)
}

// NodeConfigPtrInput is an input type that accepts NodeConfigArgs, NodeConfigPtr and NodeConfigPtrOutput values.
// You can construct a concrete instance of `NodeConfigPtrInput` via:
//
//	        NodeConfigArgs{...}
//
//	or:
//
//	        nil
type NodeConfigPtrInput interface {
	pulumi.Input

	ToNodeConfigPtrOutput() NodeConfigPtrOutput
	ToNodeConfigPtrOutputWithContext(context.Context) NodeConfigPtrOutput
}

type nodeConfigPtrType NodeConfigArgs

func NodeConfigPtr(v *NodeConfigArgs) NodeConfigPtrInput {
	return (*nodeConfigPtrType)(v)
}

func (*nodeConfigPtrType) ElementType() reflect.Type {
	return reflect.TypeOf((**NodeConfig)(nil)).Elem()
}

func (i *nodeConfigPtrType) ToNodeConfigPtrOutput() NodeConfigPtrOutput {
	return i.ToNodeConfigPtrOutputWithContext(context.Background())
}

func (i *nodeConfigPtrType) ToNodeConfigPtrOutputWithContext(ctx context.Context) NodeConfigPtrOutput {
	return pulumi.ToOutputWithContext(ctx, i).(NodeConfigPtrOutput)
}

type NodeConfigOutput struct{ *pulumi.OutputState }

func (NodeConfigOutput) ElementType() reflect.Type {
	return reflect.TypeOf((*NodeConfig)(nil)).Elem()
}

func (o NodeConfigOutput) ToNodeConfigOutput() NodeConfigOutput {
	return o
}

func (o NodeConfigOutput) ToNodeConfigOutputWithContext(ctx context.Context) NodeConfigOutput {
	return o
}

func (o NodeConfigOutput) ToNodeConfigPtrOutput() NodeConfigPtrOutput {
	return o.ToNodeConfigPtrOutputWithContext(context.Background())
}

func (o NodeConfigOutput) ToNodeConfigPtrOutputWithContext(ctx context.Context) NodeConfigPtrOutput {
	return o.ApplyTWithContext(ctx, func(_ context.Context, v NodeConfig) *NodeConfig {
		return &v
	}).(NodeConfigPtrOutput)
}

func (o NodeConfigOutput) Connection() ConnectionConfigPtrOutput {
	return o.ApplyT(func(v NodeConfig) *ConnectionConfig { return v.Connection }).(ConnectionConfigPtrOutput)
}

func (o NodeConfigOutput) Disks() DiskConfigOutput {
	return o.ApplyT(func(v NodeConfig) DiskConfig { return v.Disks }).(DiskConfigOutput)
}

func (o NodeConfigOutput) Host() pulumi.StringOutput {
	return o.ApplyT(func(v NodeConfig) string { return v.Host }).(pulumi.StringOutput)
}

type NodeConfigPtrOutput struct{ *pulumi.OutputState }

func (NodeConfigPtrOutput) ElementType() reflect.Type {
	return reflect.TypeOf((**NodeConfig)(nil)).Elem()
}

func (o NodeConfigPtrOutput) ToNodeConfigPtrOutput() NodeConfigPtrOutput {
	return o
}

func (o NodeConfigPtrOutput) ToNodeConfigPtrOutputWithContext(ctx context.Context) NodeConfigPtrOutput {
	return o
}

func (o NodeConfigPtrOutput) Elem() NodeConfigOutput {
	return o.ApplyT(func(v *NodeConfig) NodeConfig {
		if v != nil {
			return *v
		}
		var ret NodeConfig
		return ret
	}).(NodeConfigOutput)
}

func (o NodeConfigPtrOutput) Connection() ConnectionConfigPtrOutput {
	return o.ApplyT(func(v *NodeConfig) *ConnectionConfig {
		if v == nil {
			return nil
		}
		return v.Connection
	}).(ConnectionConfigPtrOutput)
}

func (o NodeConfigPtrOutput) Disks() DiskConfigPtrOutput {
	return o.ApplyT(func(v *NodeConfig) *DiskConfig {
		if v == nil {
			return nil
		}
		return &v.Disks
	}).(DiskConfigPtrOutput)
}

func (o NodeConfigPtrOutput) Host() pulumi.StringPtrOutput {
	return o.ApplyT(func(v *NodeConfig) *string {
		if v == nil {
			return nil
		}
		return &v.Host
	}).(pulumi.StringPtrOutput)
}

type PartitionConfig struct {
	Db  string `pulumi:"db"`
	Osd string `pulumi:"osd"`
	Wal string `pulumi:"wal"`
}

// PartitionConfigInput is an input type that accepts PartitionConfigArgs and PartitionConfigOutput values.
// You can construct a concrete instance of `PartitionConfigInput` via:
//
//	PartitionConfigArgs{...}
type PartitionConfigInput interface {
	pulumi.Input

	ToPartitionConfigOutput() PartitionConfigOutput
	ToPartitionConfigOutputWithContext(context.Context) PartitionConfigOutput
}

type PartitionConfigArgs struct {
	Db  pulumi.StringInput `pulumi:"db"`
	Osd pulumi.StringInput `pulumi:"osd"`
	Wal pulumi.StringInput `pulumi:"wal"`
}

func (PartitionConfigArgs) ElementType() reflect.Type {
	return reflect.TypeOf((*PartitionConfig)(nil)).Elem()
}

func (i PartitionConfigArgs) ToPartitionConfigOutput() PartitionConfigOutput {
	return i.ToPartitionConfigOutputWithContext(context.Background())
}

func (i PartitionConfigArgs) ToPartitionConfigOutputWithContext(ctx context.Context) PartitionConfigOutput {
	return pulumi.ToOutputWithContext(ctx, i).(PartitionConfigOutput)
}

type PartitionConfigOutput struct{ *pulumi.OutputState }

func (PartitionConfigOutput) ElementType() reflect.Type {
	return reflect.TypeOf((*PartitionConfig)(nil)).Elem()
}

func (o PartitionConfigOutput) ToPartitionConfigOutput() PartitionConfigOutput {
	return o
}

func (o PartitionConfigOutput) ToPartitionConfigOutputWithContext(ctx context.Context) PartitionConfigOutput {
	return o
}

func (o PartitionConfigOutput) Db() pulumi.StringOutput {
	return o.ApplyT(func(v PartitionConfig) string { return v.Db }).(pulumi.StringOutput)
}

func (o PartitionConfigOutput) Osd() pulumi.StringOutput {
	return o.ApplyT(func(v PartitionConfig) string { return v.Osd }).(pulumi.StringOutput)
}

func (o PartitionConfigOutput) Wal() pulumi.StringOutput {
	return o.ApplyT(func(v PartitionConfig) string { return v.Wal }).(pulumi.StringOutput)
}

type SSD struct {
	Id         string          `pulumi:"id"`
	Partitions PartitionConfig `pulumi:"partitions"`
}

// SSDInput is an input type that accepts SSDArgs and SSDOutput values.
// You can construct a concrete instance of `SSDInput` via:
//
//	SSDArgs{...}
type SSDInput interface {
	pulumi.Input

	ToSSDOutput() SSDOutput
	ToSSDOutputWithContext(context.Context) SSDOutput
}

type SSDArgs struct {
	Id         pulumi.StringInput   `pulumi:"id"`
	Partitions PartitionConfigInput `pulumi:"partitions"`
}

func (SSDArgs) ElementType() reflect.Type {
	return reflect.TypeOf((*SSD)(nil)).Elem()
}

func (i SSDArgs) ToSSDOutput() SSDOutput {
	return i.ToSSDOutputWithContext(context.Background())
}

func (i SSDArgs) ToSSDOutputWithContext(ctx context.Context) SSDOutput {
	return pulumi.ToOutputWithContext(ctx, i).(SSDOutput)
}

// SSDArrayInput is an input type that accepts SSDArray and SSDArrayOutput values.
// You can construct a concrete instance of `SSDArrayInput` via:
//
//	SSDArray{ SSDArgs{...} }
type SSDArrayInput interface {
	pulumi.Input

	ToSSDArrayOutput() SSDArrayOutput
	ToSSDArrayOutputWithContext(context.Context) SSDArrayOutput
}

type SSDArray []SSDInput

func (SSDArray) ElementType() reflect.Type {
	return reflect.TypeOf((*[]SSD)(nil)).Elem()
}

func (i SSDArray) ToSSDArrayOutput() SSDArrayOutput {
	return i.ToSSDArrayOutputWithContext(context.Background())
}

func (i SSDArray) ToSSDArrayOutputWithContext(ctx context.Context) SSDArrayOutput {
	return pulumi.ToOutputWithContext(ctx, i).(SSDArrayOutput)
}

type SSDOutput struct{ *pulumi.OutputState }

func (SSDOutput) ElementType() reflect.Type {
	return reflect.TypeOf((*SSD)(nil)).Elem()
}

func (o SSDOutput) ToSSDOutput() SSDOutput {
	return o
}

func (o SSDOutput) ToSSDOutputWithContext(ctx context.Context) SSDOutput {
	return o
}

func (o SSDOutput) Id() pulumi.StringOutput {
	return o.ApplyT(func(v SSD) string { return v.Id }).(pulumi.StringOutput)
}

func (o SSDOutput) Partitions() PartitionConfigOutput {
	return o.ApplyT(func(v SSD) PartitionConfig { return v.Partitions }).(PartitionConfigOutput)
}

type SSDArrayOutput struct{ *pulumi.OutputState }

func (SSDArrayOutput) ElementType() reflect.Type {
	return reflect.TypeOf((*[]SSD)(nil)).Elem()
}

func (o SSDArrayOutput) ToSSDArrayOutput() SSDArrayOutput {
	return o
}

func (o SSDArrayOutput) ToSSDArrayOutputWithContext(ctx context.Context) SSDArrayOutput {
	return o
}

func (o SSDArrayOutput) Index(i pulumi.IntInput) SSDOutput {
	return pulumi.All(o, i).ApplyT(func(vs []interface{}) SSD {
		return vs[0].([]SSD)[vs[1].(int)]
	}).(SSDOutput)
}

func init() {
	pulumi.RegisterInputType(reflect.TypeOf((*ChunkConfigInput)(nil)).Elem(), ChunkConfigArgs{})
	pulumi.RegisterInputType(reflect.TypeOf((*ChunkConfigPtrInput)(nil)).Elem(), ChunkConfigArgs{})
	pulumi.RegisterInputType(reflect.TypeOf((*ClusterConfigInput)(nil)).Elem(), ClusterConfigArgs{})
	pulumi.RegisterInputType(reflect.TypeOf((*ClusterConfigPtrInput)(nil)).Elem(), ClusterConfigArgs{})
	pulumi.RegisterInputType(reflect.TypeOf((*ConnectionInput)(nil)).Elem(), ConnectionArgs{})
	pulumi.RegisterInputType(reflect.TypeOf((*ConnectionConfigInput)(nil)).Elem(), ConnectionConfigArgs{})
	pulumi.RegisterInputType(reflect.TypeOf((*ConnectionConfigPtrInput)(nil)).Elem(), ConnectionConfigArgs{})
	pulumi.RegisterInputType(reflect.TypeOf((*DiskInput)(nil)).Elem(), DiskArgs{})
	pulumi.RegisterInputType(reflect.TypeOf((*DiskArrayInput)(nil)).Elem(), DiskArray{})
	pulumi.RegisterInputType(reflect.TypeOf((*DiskConfigInput)(nil)).Elem(), DiskConfigArgs{})
	pulumi.RegisterInputType(reflect.TypeOf((*DiskConfigPtrInput)(nil)).Elem(), DiskConfigArgs{})
	pulumi.RegisterInputType(reflect.TypeOf((*DiskSpecInput)(nil)).Elem(), DiskSpecArgs{})
	pulumi.RegisterInputType(reflect.TypeOf((*NodeConfigInput)(nil)).Elem(), NodeConfigArgs{})
	pulumi.RegisterInputType(reflect.TypeOf((*NodeConfigPtrInput)(nil)).Elem(), NodeConfigArgs{})
	pulumi.RegisterInputType(reflect.TypeOf((*PartitionConfigInput)(nil)).Elem(), PartitionConfigArgs{})
	pulumi.RegisterInputType(reflect.TypeOf((*SSDInput)(nil)).Elem(), SSDArgs{})
	pulumi.RegisterInputType(reflect.TypeOf((*SSDArrayInput)(nil)).Elem(), SSDArray{})
	pulumi.RegisterOutputType(ChunkConfigOutput{})
	pulumi.RegisterOutputType(ChunkConfigPtrOutput{})
	pulumi.RegisterOutputType(ClusterConfigOutput{})
	pulumi.RegisterOutputType(ClusterConfigPtrOutput{})
	pulumi.RegisterOutputType(ConnectionOutput{})
	pulumi.RegisterOutputType(ConnectionConfigOutput{})
	pulumi.RegisterOutputType(ConnectionConfigPtrOutput{})
	pulumi.RegisterOutputType(DiskOutput{})
	pulumi.RegisterOutputType(DiskArrayOutput{})
	pulumi.RegisterOutputType(DiskConfigOutput{})
	pulumi.RegisterOutputType(DiskConfigPtrOutput{})
	pulumi.RegisterOutputType(DiskSpecOutput{})
	pulumi.RegisterOutputType(NodeConfigOutput{})
	pulumi.RegisterOutputType(NodeConfigPtrOutput{})
	pulumi.RegisterOutputType(PartitionConfigOutput{})
	pulumi.RegisterOutputType(SSDOutput{})
	pulumi.RegisterOutputType(SSDArrayOutput{})
}
